unit gfxlib_DEMOFRM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, gfx_basedef, gfx_effects, gfx_files, gfx_rotresize,
  gfx_crypt,gfx_masks,ExtDlgs,
  Menus;

type
  TForm1 = class(TForm)
    OpenPictureDialog1: TOpenPictureDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Effects1: TMenuItem;
    Filters1: TMenuItem;
    Image1: TImage;
    Colors1: TMenuItem;
    Resample1: TMenuItem;
    Rotate1: TMenuItem;
    Deformations1: TMenuItem;
    Solarize1: TMenuItem;
    Negative1: TMenuItem;
    Flip1: TMenuItem;
    Miror1: TMenuItem;
    Oldlook1: TMenuItem;
    Flip121: TMenuItem;
    Mirror121: TMenuItem;
    Grayscale1: TMenuItem;
    Crypt1: TMenuItem;
    Encrypt1: TMenuItem;
    Decrypt1: TMenuItem;
    MagicWand1: TMenuItem;
    procedure OpenClick(Sender: TObject);
    procedure EffectsClick(Sender: TObject);
    procedure Colors1Click(Sender: TObject);
    procedure Resample1Click(Sender: TObject);
    procedure Rotate1Click(Sender: TObject);
    procedure Deformations1Click(Sender: TObject);
    procedure Solarize1Click(Sender: TObject);
    procedure MiscClick(Sender: TObject);
    procedure Encrypt1Click(Sender: TObject);
    procedure Decrypt1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MagicWand1Click(Sender: TObject);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  TempBitmap:TBitmap;
  
implementation

uses gfx_FilterCtrl, gfx_ColorCtrl, gfx_resizectrl, gfx_RotateCtrl,
  gfx_EffectCtrl, gfx_SolCtrl;

{$R *.DFM}

procedure TForm1.OpenClick(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then
  begin
    LoadAnyImageToBMP(Image1.Picture.Bitmap,OpenPictureDialog1.FileName,False,0,0);
    Effects1.Enabled:=True;
  end;
end;

procedure TForm1.EffectsClick(Sender: TObject);
begin
  FilterCtrlForm:=TFilterCtrlForm.Create(Application);
  try
    FilterCtrlForm.PreviewPanel1.SourceBitmap.Assign(Image1.Picture.Bitmap);
    FilterCtrlForm.ShowModal;
    if FilterCtrlForm.ModalResult=IDOK then
    begin
      Image1.Picture.Bitmap.Assign(FilterCtrlForm.ResultBitmap);
      Image1.Repaint;
    end;
  finally
    FilterCtrlForm.Free;
  end;
end;

procedure TForm1.Colors1Click(Sender: TObject);
begin
  ColCtrlForm:=TColCtrlForm.Create(Application);
  try
    ColCtrlForm.PreviewPanel1.SourceBitmap.Assign(Image1.Picture.Bitmap);
    ColCtrlForm.ShowModal;
    if ColCtrlForm.ModalResult=IDOK then
    begin
      Image1.Picture.Bitmap.Assign(ColCtrlForm.ResultBitmap);
      Image1.Repaint;
    end;
  finally
    ColCtrlForm.Free;
  end;
end;

procedure TForm1.Resample1Click(Sender: TObject);
begin
  ResizeCtrlForm:=TResizeCtrlForm.Create(Application);
  try
    ResizeCtrlForm.FSrcBitmap.Assign(Image1.Picture.Bitmap);
    ResizeCtrlForm.ShowModal;
    if ResizeCtrlForm.ModalResult=IDOK then
    begin
      Image1.Picture.Bitmap.Assign(ResizeCtrlForm.FDestBitmap);
      Image1.Repaint;
    end;
  finally
    ResizeCtrlForm.Free;
  end;
end;

procedure TForm1.Rotate1Click(Sender: TObject);
begin
  RotCtrlForm:=TRotCtrlForm.Create(Application);
  try
    RotCtrlForm.SrcBitmap.Assign(Image1.Picture.Bitmap);
    RotCtrlForm.ShowModal;
    if RotCtrlForm.ModalResult=IDOK then
    begin
      Image1.Picture.Bitmap.Assign(RotCtrlForm.DestBitmap);
      Image1.Repaint;
    end;
  finally
    RotCtrlForm.Free;
  end;
end;

procedure TForm1.Deformations1Click(Sender: TObject);
begin
  EffectCtrlForm:=TEffectCtrlForm.Create(Application);
  try
    EffectCtrlForm.PreviewPanel1.SourceBitmap.Assign(Image1.Picture.Bitmap);
    EffectCtrlForm.ShowModal;
    if EffectCtrlForm.ModalResult=IDOK then
    begin
      Image1.Picture.Bitmap.Assign(EffectCtrlForm.ResultBitmap);
      Image1.Repaint;
    end;
  finally
    EffectCtrlForm.Free;
  end;
end;

procedure TForm1.Solarize1Click(Sender: TObject);
begin
  SolCtrlForm:=TSolCtrlForm.Create(Application);
  try
    SolCtrlForm.PreviewPanel1.SourceBitmap.Assign(Image1.Picture.Bitmap);
    SolCtrlForm.ShowModal;
    if SolCtrlForm.ModalResult=IDOK then
    begin
      Image1.Picture.Bitmap.Assign(SolCtrlForm.ResultBitmap);
      Image1.Repaint;
    end;
  finally
    SolCtrlForm.Free;
  end;
end;

procedure TForm1.MiscClick(Sender: TObject);
var TempBmp,tb:TBitmap;

begin
   TempBMP:=TBitmap.Create;
   TB:=TBitmap.Create;
   try
      case (Sender as TMenuItem).Tag of
      1:begin
            FlipBitmap(Image1.Picture.Bitmap,TempBmp,nil);
            Image1.Picture.Bitmap.Assign(TempBMP);
        end;
      2:begin
             MirrorBitmap(Image1.Picture.Bitmap,TempBmp,nil);
             Image1.Picture.Bitmap.Assign(TempBMP);
        end;
      3:
        begin
            EffectNegative(Image1.Picture.Bitmap,TempBMP,nil);
            Image1.Picture.Bitmap.Assign(TempBMP);
        end;
      4:begin
            EffectGreyScale(Image1.Picture.Bitmap,TempBmp,nil);
            Image1.Picture.Bitmap.Assign(TempBMP);
        end;
      5:begin
            FlipBitmap(Image1.Picture.Bitmap,Image1.Picture.Bitmap,nil);
         end;
      6:begin
          MirrorBitmap(Image1.Picture.Bitmap,Image1.Picture.Bitmap,nil);
        end;
      7:begin
          EffectGreyScale(Image1.Picture.Bitmap,Image1.Picture.Bitmap,nil);
        end;
      end;
   finally
      TempBmp.Free;
      TB.Free;
      Image1.RePaint;
  end;
end;

procedure TForm1.Encrypt1Click(Sender: TObject);
var EncryptVal:Integer;
begin
     EncryptVal:= StrToInt(InputBox('Enter Value','Encryption Value','0'));
     EncryptBMP(Image1.Picture.Bitmap,TempBitmap,EncryptVal);
     Image1.Picture.Bitmap.Canvas.Draw(0,0,TempBitmap);
     Image1.Repaint;
     Decrypt1.Enabled:=True;
end;

procedure TForm1.Decrypt1Click(Sender: TObject);
var DecryptVal:Integer;
begin
     DecryptVal:= StrToInt(InputBox('Enter Value','Decryption Value','0'));
     DecryptBMP(TempBitmap,Image1.Picture.Bitmap,DecryptVal);
     Image1.Repaint;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TempBitmap:=TBitmap.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 TempBitmap.Free;
end;

procedure TForm1.MagicWand1Click(Sender: TObject);
begin
  MagicWand1.Checked:=not MagicWand1.Checked;
  
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  mask:tbool2darray;
begin
  if MagicWand1.Checked then
  begin
    TempBitmap.Assign(Image1.Picture.Bitmap);
    Maskmagicwand(TempBitmap,x,y,TempBitmap.canvas.pixels[x,y],0.3,mask);
    ShowMagicWandFrame(TempBitmap,TempBitmap,mask);
    mask:=nil;
    Image1.Picture.Bitmap.Assign(TempBitmap);
  end;
end;

end.
